<?php
/*************************************************************************************/
/*                                                                                   */
/*      Plugin planning produit pour Thelia                                  		 */
/*                                                                                   */
/*      Copyright (c) Franck Allimant		                                         */
/*		email : thelia@allimant.org           	                             	     */
/*                                                                                   */
/*      This program is free software; you can redistribute it and/or modify         */
/*      it under the terms of the GNU General Public License as published by         */
/*      the Free Software Foundation; either version 2 of the License, or            */
/*      (at your option) any later version.                                          */
/*                                                                                   */
/*      This program is distributed in the hope that it will be useful,              */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of               */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                */
/*      GNU General Public License for more details.                                 */
/*                                                                                   */
/*      You should have received a copy of the GNU General Public License            */
/*      along with this program; if not, write to the Free Software                  */
/*      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA    */
/*                                                                                   */
/*************************************************************************************/
?>
<?php
include_once(realpath(dirname(__FILE__)) . "/../../../classes/PluginsClassiques.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Navigation.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Panier.class.php");

class Filtragetransports extends PluginsClassiques 
{    
	var $id;
	var $transport;
	var $critere;
	var $valeur;

	var $table = "filtragetransports";
	
	var $bddvars = array("id", "transport", "critere", "valeur");		

	function Filtragetransports()
    {
	   $this->PluginsClassiques("filtragetransport");
	   
	   $this->critere = 'toujours';
	   $this->valeur = '';
	}
	
	function init()
	{
        $this->ajout_desc(
            "filtragetransport", 
            "Filtrage sur critres des transports", 
            "Ce plugin permet de filtrer les transport suivant des critres dfinis dans le BO. Par exemple, il n'affichera pas le transport Colissimo si le poinds du panier est suprieur  30 Kg."
        );
        
		$query = "CREATE TABLE IF NOT EXISTS filtragetransports (
		  id int(11) NOT NULL auto_increment,
		  transport int(11) NOT NULL,
		  critere varchar(10) not null default 'toujours',
		  valeur text not null default '',
		  PRIMARY KEY  (id),
		  KEY key_transport (transport)
		);";
		
		$result = mysql_query($query);		
		
		if (! $result) 
		{
			die("Echec  la creation de la table filtragetransports, avec l'erreur: " . mysql_error());
		}
	}
	
	function charger_transport($transport)
	{
		$this->transport = $transport;
		
		return $this->getVars('select * from ' . $this->table . ' where transport=' . intval($transport));
	}
	
	function boucle($texte, $args)
	{
		$res = '';
		
		// Appeler la boucle transport, pour rcuprer les transports possibles
		$txt_infos = boucleTransport('#ID:#PORT;', $args);

		        // Retirer le dernier ';'
        $txt_infos = substr($txt_infos, 0, -1);
        
        // Rappeller la boucle pour chaque produit trouv
        $arr_infos = explode(';', $txt_infos);
        
        $id_valides = array();
        
        foreach($arr_infos as $info)
        {
        	list($id, $port) = explode(':', $info);
      	
        	if ($this->ignorer(
					$id,
					$_SESSION['navig']->panier->poids(),
					$_SESSION['navig']->panier->nbart(),
					$_SESSION['navig']->panier->total(),
					$port
        	)) continue;        	
        	
        	$id_valides[] = $id;
        }
        
        if (count($id_valides) > 0)
        {
        	// Imposer  la boucle transport de ne travailler que sur les IDs trouvs
        	$pargs = preg_replace('/id="[^"]+"/', '', $args) . ' id="'.implode(',', $id_valides) . '"';   

        	$res = boucleTransport($texte, $pargs);
        	
        	$res = str_replace('#POIDS', $_SESSION['navig']->panier->poids(), $res);
        	$res = str_replace('#NBART', $_SESSION['navig']->panier->nbart(), $res);
        	$res = str_replace('#TOTAL', $_SESSION['navig']->panier->total(), $res);
        }
        
        return $res;
	}
	
	function ignorer($id_transport, $poids, $nbart, $montant, $port_calcule)
	{
		$ignorer = true;
		
		if ($this->charger_transport($id_transport))
		{      		
			$ignorer = true;
			
			switch($this->critere)
			{
				case 'toujours':
					// On garde
					$ignorer = false;
				break;
				
				case 'jamais':
					// On ne garde pas
					$ignorer = true;
				break;
				
				case 'nonzero':
					$ignorer = $port_calcule <= 0;
				break;
				
				case 'poids':
					list($comp_poids_mini, $poids_mini, $comp_poids_maxi, $poids_maxi) = explode(':', $this->valeur);
					
					$exp = '$match = $poids '.$comp_poids_mini.' '.$poids_mini.' && $poids '.$comp_poids_maxi.' '.$poids_maxi.';';
					
					eval($exp);
					
					//echo "critere=$this->critere, exp=$exp,poids=$poids, match=$match<br />".
					
					// Evaluer le poids du panier
					$ignorer = ! $match;
				break;
				
				case 'montant':
					list($comp_montant_mini, $montant_mini, $comp_montant_maxi, $montant_maxi) = explode(':', $this->valeur);
					
					$exp = '$match = $montant '.$comp_montant_mini.' '.$montant_mini.' && $montant '.$comp_montant_maxi.' '.$montant_maxi.';';
					
					eval($exp);
					
					//echo "critere=$this->critere, exp=$exp,poids=$poids, match=$match<br />".
					
					$ignorer = ! $match;
				break;
				
				case 'nbart':
					list($comp_nbart_mini, $nbart_mini, $comp_nbart_maxi, $nbart_maxi) = explode(':', $this->valeur);
					
					$exp = '$match = $nbart '.$comp_nbart_mini.' '.$nbart_mini.' && $nbart '.$comp_nbart_maxi.' '.$nbart_maxi.';';
					
					eval($exp);

					$ignorer = ! $match;
				break;
			}
		}
		
		return $ignorer;
	}
}
