<?php
include_once(realpath(dirname(__FILE__)) . "/../../../fonctions/authplugins.php");
autorisation("filtragetransports");

require_once(realpath(dirname(__FILE__)) . '/../../../classes/Baseobj.class.php');
require_once(realpath(dirname(__FILE__)) . '/../../../classes/Modules.class.php');
require_once(realpath(dirname(__FILE__)) . '/../../../classes/Modulesdesc.class.php');
require_once(realpath(dirname(__FILE__)) . '/Filtragetransports.class.php');


class FiltrageTransportsAdmin
{
    var $liste_modules;
    var $types_criteres;
    var $calcul;
    
    function FiltrageTransportsAdmin()
    {       
    	$this->calcul = false;
    	
    	$this->types_criteres = array(
    		'poids'   => array('nom' => 'poids', 'unite' => 'Kg'),
    		'montant' => array('nom' => 'montant', 'unite' => '&euro;'), 
    		'nbart'   => array('nom' => 'nombre d\'articles', 'unite' => '') );
    }
    
    function modifier()
    {
		foreach($_REQUEST['critere'] as $id => $critere)
        {
        	$info_module = new Filtragetransports();
        	
        	if ($info_module->charger_transport($id))
        	{
        		$this->maj_info_module($info_module, $id, $critere);

        		$info_module->maj();
        	}
        	else
        	{
        		$this->maj_info_module($info_module, $id, $critere);
        		
        		$info_module->add();
        	}
        }
         
        // Vider le cache des requtes (s'il existe)
        if (method_exists('Baseobj','viderCache')) Baseobj::viderCache();
    }

    public function critere_select($info_module, $critere, $label)
    {
    	$selected = $info_module->critere == $critere ? ' selected="selected"' : '';
    	
    	return '<option value="'.$critere.'"'.$selected.'>'.$label.'</option>';
    }
    
    public function select_type_borne($info_module, $prefixe, $comp, $val)
    {
    	return '<select name="comp_'.$prefixe.'['.$info_module->transport.']">
    	<option value="'.$comp.'"'.($val == $comp ? 'selected="selected"' : '').'>'.htmlspecialchars($comp).'</option>
					<option value="'.$comp.'="'.($val == "$comp=" ? 'selected="selected"' : '').'>'.htmlspecialchars($comp).'=</option>
				</select>';
    }
    
    public function calculer()
    {
    	$modules = new Modules();
    	
    	$ft = new Filtragetransports();
    	
    	$result = mysql_query("select * from $modules->table where type='2' and actif='1' order by classement");
    	
    	while ($result && $row = mysql_fetch_object($result))
    	{
    		if ($ft->ignorer(
    				$row->id,
    				floatval($_REQUEST['poids']),
    				floatval($_REQUEST['nbart']),
    				floatval($_REQUEST['montant']),
    				floatval($_REQUEST['fraisdeport']) ) ) continue;
 		
    		$this->calcul .= ($this->calcul != '' ? ',' : '') . $row->nom;
    	}
     }
    
    public function lister_modules()
    {
        $this->moduledesc = array();
        
        $modules = new Modules();
       
        $query = "select id from $modules->table where type='2' and actif='1' $search order by classement";
        
	    $result = mysql_query($query);
	
	    while($result && $row = mysql_fetch_object($result))
        {
        	$module = new Modules();
        	$module->charger_id($row->id);
        	
            $this->liste_modules[$row->id]['module'] = $module;
            
            $info_module = new Filtragetransports();
            
            $info_module->charger_transport($row->id);
            
            $this->liste_modules[$row->id]['info'] = $info_module;
        }
    }   
    
    private function maj_info_module($info_module, $id, $critere)
    {
		$info_module->transport = $id;
		
		$info_module->critere = $critere;
	
		foreach($this->types_criteres as $tc => $data)
		{
			if ($critere == $tc && $_REQUEST["${tc}_mini"][$id] != '' && $_REQUEST["${tc}_maxi"][$id] != '')
			{
				$info_module->valeur = 
					  $_REQUEST["comp_${tc}_mini"][$id] . ':'
					  . floatval($_REQUEST["${tc}_mini"][$id]) . ':'
					  . $_REQUEST["comp_${tc}_maxi"][$id] . ':'
					  . floatval($_REQUEST["${tc}_maxi"][$id]);			
			}
		}
    }
}
    
// -- MAIN -------------------------------------------------------------------------------------

    $adm = new FiltrageTransportsAdmin();
    
    $command = $_REQUEST['fp_command'];
        
    switch($command)
    {
        case 'modifier' :
            $adm->modifier();
        break;
        
        case 'calculer' :
            $adm->calculer();
        break;
    }
    
    $adm->lister_modules();
?>
<style type="text/css">
td {
    height: 30px;
    padding: 4px;
}

.fonction_valider {
   float: right;
}

#bloc_description table td.pad {
	padding: 5px;
}
</style>

<script type="text/javascript" src="../lib/jquery/jquery.js"></script>
<script type="text/javascript">

    function modifier_infos()
    {
    	var correct = true;
    	
    	$('select[name^=critere]').each(function() {
    		
    		// Une erreur  la fois !
    		if (! correct) return;
    		
    		var val = $(this).val();
    		var idx = $(this).attr('name').replace(/critere\[([0-9]+)\]/, "$1");
    		
    		var criteres = new Array('poids', 'total', 'nbart');
    		
    		$.each(['poids', 'montant', 'nbart'], function(index, critere) 
    		{ 
				if (val == critere)
				{
					var mini = $('#'+critere+'_mini_'+idx).val().replace(',', '.');
					var maxi = $('#'+critere+'_maxi_'+idx).val().replace(',', '.');
					
					if (mini == '' || isNaN(parseFloat(mini)))
					{
						alert("Vous devez indiquer un "+critere+" minimum valide.");
						$('#'+critere+'_mini_'+idx).focus();
						correct = false;
						return;
					}
					
					if (maxi == '' || isNaN(parseFloat(maxi)))
					{
						alert("Vous devez indiquer un "+critere+" maximum valide.");
						$('#'+critere+'_maxi_'+idx).focus();
						correct = false;
						return;
					}
					
					if (parseFloat(maxi) <= parseFloat(mini))
					{
						alert("Le "+critere+" minimum doit tre suprieur au "+critere+" maximum");
						$('#'+critere+'_mini_'+idx).focus();
						correct = false;
						return;
					}
				}
			});
    	});
        
        if (correct) $('#fp_form').submit();
    }
    
    function fp_show_blocks(id)
    {
    	var critere = $('#critere_' + id).val();
    	
    	$('div[id^=info_' + id+']').hide();
    	
    	$('div[id=info_'  + id + '_' + critere  + ']').show();
    }
</script>

<div id="contenu_int"> 
<p class="geneva11Reg_3B4B5B"><a href="accueil.php" class="lien04">Accueil </a> <img src="gfx/suivant.gif" width="12" height="9" border="0" /><a href="#" class="lien04">Filtrage sur critres des plugins transport</a></p>

<div id="bloc_description">

<form action="<?php echo $_SERVER['PHP_SELF'] ?>" id="fp_form" method="post">
	<input type="hidden" name="nom" value="filtragetransports" />
	<input type="hidden" name="fp_command" value="modifier"/>
	
	<div class="entete">
		<div class="titre">INFORMATION</div>
	</div>

	<table width="100%" cellpadding="5" cellspacing="0">
	
		<tr class="clairebottom">
			<td>
			<p>Ce plugin vous permet de rgler finement les types de transport qui sont proposs  vos clients, 
			en fonction du contenu de leur panier. Exemple: si le poids du panier dpasse 30 Kilos, il n'est pas possible d'utiliser le transport par
			Colissimo, ou Colissimo International.</p>
			<p>Indiquez ci-dessous les conditions dans lesquelles un transport est propos au client.</p>
			<p>Un outil de test en bas de page vous permet de raliser quelques simulations, et de vrifier votre configuration.</p>
			<p align="right"><a href="../client/plugins/filtragetransports/readme_viewer.php" target="readme">Lire le fichier LISEZMOI</a> du plugin.</p>
			</td>
		</tr>
	</table>

	<div class="entete">
		<div class="titre">LISTE DES PLUGINS TRANSPORT ACTIFS</div>
		<div class="fonction_valider"><a href="#" onclick="modifier_infos()">VALIDER LES MODIFICATIONS</a></div>
	</div>
	
	<table width="100%" cellpadding="5" cellspacing="0">
	<tr>
		<th class="designation">NOM DU PLUGIN</th>
		<th>CONDITION D'UTILISATION DU PLUGIN</th>
	</tr>
	<?php 
	$style="fonce";
	
	foreach($adm->liste_modules as $id => $module) 
	{ 
		$tid = $module['info']->transport;
	?>
	<tr class="<?php echo $style; ?>">
	<td class="designation"><?php echo $module['module']->nom; ?><br /><span style="font-size: 0.8em; font-style: italic;">ID du plugin: <?php echo $module['module']->id; ?></span></td>
		<td>
		<select id="critere_<?php echo $tid ?>" name="critere[<?php echo $tid ?>]" onchange="fp_show_blocks(<?php echo $tid ?>)">
			<?php 
			echo $adm->critere_select($module['info'], 'toujours', 'Toujours utilis'); 
			echo $adm->critere_select($module['info'], 'jamais', 'Jamais utilis');
			echo $adm->critere_select($module['info'], 'nonzero', 'Si il retourne des frais de port suprieurs  0,00 &euro;');
			
			foreach($adm->types_criteres as $tc => $data) 
			{
				echo $adm->critere_select($module['info'], $tc, 'Si le '.$data['nom'].' du panier est...');
			}
			?>
		</select>
		
		<?php
		foreach($adm->types_criteres as $tc => $data) 
		{
			list($comp_mini, $mini, $comp_maxi, $maxi) = explode(':', $module['info']->valeur);
		?>	
		<div id="info_<?php echo $tid . '_' . $tc ?>" style="margin-top: 5px; display: <?php echo $module['info']->critere == $tc ? 'block' : 'none'?>;">
				<?php echo $adm->select_type_borne($module['info'], $tc.'_mini', '>', $comp_mini) ?>
				<input type="text" id="<?php echo $tc; ?>_mini_<?php echo $tid ?>" name="<?php echo $tc; ?>_mini<?php echo '['.$tid.']' ?>" size="5" value="<?php echo $mini ?>"/><?php echo $data['unite'] ?>
				et 
				<?php echo $adm->select_type_borne($module['info'], $tc.'_maxi', '<', $comp_maxi) ?>
				 
				<input type="text" id="<?php echo $tc; ?>_maxi_<?php echo $tid ?>"  name="<?php echo $tc; ?>_maxi<?php echo '['.$tid.']' ?>" size="5" value="<?php echo $maxi ?>"/><?php echo $data['unite'] ?>
			</div>
		<?php } ?>
		</td>
	</tr>
	<?php 
		$style = $style == 'claire' ? 'fonce' : 'claire';	

	} 
	?>
	<tr>
	<td style="height: 12px;" class="<?php echo "{$style}bottom"; ?>" colspan="2">&nbsp;</td>
	</tr>
	</table>
</form>
<a name="calcul"></a>
<form action="<?php echo $_SERVER['PHP_SELF'] ?>#calcul" id="fp_calcul_form" method="post">
	<input type="hidden" name="nom" value="filtragetransports" />
	<input type="hidden" name="fp_command" value="calculer"/>
	
	<table cellspacing="0" cellpadding="0">
		<tr>
			<th colspan="2">
			<div class="entete_liste">
			<div class="titre">TEST: Indiquez les informations d'un panier</div>
				<div class="fonction_valider"><a href="#" onclick="$('#fp_calcul_form').submit()">AFFICHER</a></div>
			  </div>
			</div>        
			</th>
		</tr>
		
		<?php
		foreach($adm->types_criteres as $tc => $data) 
		{
		?>
		
		<tr>
			<td class="designation pad"><?php echo $data['nom']; ?></td>
			<td class="claire pad"><input type="text" size="5" name="<?php echo $tc; ?>"  value="<?php echo $_REQUEST[$tc]; ?>" /> <?php echo $data['unite']; ?></td>
		</tr>
			
		<?php
		}
		?>
		<tr>
			<td class="designation pad">frais de port</td>
			<td class="claire pad"><input type="text" size="5" name="fraisdeport" value="<?php echo $_REQUEST['fraisdeport']; ?>" /> <?php echo $data['unite']; ?></td>
		</tr>
		
		<tr>
		<td style="height: 5px; padding: 0;" class="clairebottom" colspan="2">&nbsp;</td>
		</tr>

		<?php if ($adm->calcul !== false) { ?>
		<tr>
			<td class="designation pad">Transports possibles</td>
			<td class="foncebottom pad" style="font-weight: bold; "><?php echo $adm->calcul ?></td>
		</tr>
		<?php } ?>
		
	</table>
</form>	

</div>

</div>
